/****************************************************************************
 *
 *  Module:       $HeadURL: http://svn2.hosted-projects.com/sh/DS1821/DS1821.c $
 *  Author:       $Author: sh $
 *  Revision:     $Revision: 7 $
 *  Date:         $Date: 2008-05-19 01:45:27 +0200 (Mo, 19 Mai 2008) $
 *
 *  Copyright:    (C) 2008 by Dipl.-Ing. Stefan Heesch
 *                address:  Bollstrasse 14, CH-5619 Bttikon, Switzerland
 *                callsign: DB7HS, HB9TWS  
 *                email:    radio@heesch.net
 *
 *  Description:  DS1821 Thermometer
 *
 ****************************************************************************/

/****************************************************************************
 * Include files
 ****************************************************************************/
 #include "ds1821.h"
 #include "lcd.h"
 #include "onewire.h"
 


volatile char s[20];
volatile int t;
volatile int r;
volatile unsigned int c;
volatile long temperature;

/****************************************************************************
 * Program entry point
 ****************************************************************************/
void THERMOMETER( void )
{
  uchar status;

  
    
  
  int i;
  
  {
     
    
     if ( w1_reset() )
     {
        lcd_gotoxy(7,2);
        lcd_puts("NA");
     }
     else
     {
        
        w1_reset(); 
        
		{
   			if( W1_IN & 1<< W1_PIN )
   				{
    				 w1_byte_wr( 0xEE );
   				}
 		}


        
        for ( i=0; i < 250; i++)
        {
            
            
            w1_reset();

            w1_byte_wr( 0xAC );
            status = w1_byte_rd();

          
            
        }
        
       
        
     
		{
		   /*char s[20];
		   int t;
		   int r;
		   unsigned int c;

		   long temperature;*/

		   w1_reset();
		   w1_byte_wr( 0xAA );			// read temp
		   t = w1_byte_rd();			// low byte
   
		   w1_reset();
		   w1_byte_wr( 0xA0 );          // read remaining count
		   r = w1_read(9);

		   w1_reset();
		   w1_byte_wr( 0x41 );          // load counter

		   w1_reset();
		   w1_byte_wr( 0xA0 );          // read slope counter
		   c = w1_read(9);

		   

		   if ( t > 0x80 ) 
		   {
		      t = t-256;
		   }

		   temperature   = 10 * t - 5;
		   temperature  += ( 10 * ( c - r )) / c ;

		   t = temperature / 10;
		   r = temperature % 10;

		   
 		}


     }
    
  }

}

/****************************************************************************
 * The end
 ****************************************************************************/

